import { L as LLMonitor } from './llmonitor-90ca24a9.js';
import { cJSON, RunType, EventName, RunEvent } from './types.js';

declare class FrontendLLMonitor extends LLMonitor {
    private userId?;
    private userProps?;
    /**
     * Identifies a user with a unique ID and properties.
     * @param {string} userId - The unique identifier for the user.
     * @param {cJSON} [userProps] - Custom properties to associate with the user.
     */
    identify(userId: string, userProps?: cJSON): void;
    /**
     * Extends the trackEvent method to include userId and userProps.
     * @param {RunType} type - The type of the run.
     * @param {EventName} event - The name of the event.
     * @param {Partial<RunEvent>} data - The data associated with the event.
     */
    trackEvent(type: RunType, event: EventName, data: Partial<RunEvent>): void;
}
declare const llmonitor: FrontendLLMonitor;

export { llmonitor as default };
